/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.blockentity;

import net.minecraft.class_124;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_2487;
import net.minecraft.class_2585;
import net.minecraft.class_2586;
import net.minecraft.class_3000;
import net.minecraft.class_3419;
import reborncore.api.IToolDrop;
import reborncore.common.util.ChatUtils;
import reborncore.common.util.StringUtils;
import techreborn.blocks.BlockAlarm;
import techreborn.init.ModSounds;
import techreborn.init.TRContent;
import techreborn.init.TRBlockEntities;
import techreborn.utils.MessageIDs;

public class AlarmBlockEntity extends class_2586
	implements class_3000, IToolDrop {
	private int selectedSound = 1;

	public AlarmBlockEntity() {
		super(TRBlockEntities.ALARM);
	}

    public void rightClick() {
        if (field_11863.field_9236) {
            return;
        }

        if (selectedSound < 3) {
            selectedSound++;
        } else {
            selectedSound = 1;
        }
        ChatUtils.sendNoSpamMessages(MessageIDs.alarmID, new class_2585(
                class_124.field_1080 + StringUtils.t("techreborn.message.alarm") + " " + "Alarm " + selectedSound));
    }
	
	// BlockEntity
	@Override
	public class_2487 method_11007(class_2487 compound) {
		if (compound == null) {
			compound = new class_2487();
		}
		compound.method_10569("selectedSound", this.selectedSound);
		return super.method_11007(compound);
	}

	@Override
	public void method_11014(class_2487 compound) {
		if (compound != null && compound.method_10545("selectedSound")) {
			selectedSound = compound.method_10550("selectedSound");
		}
		super.method_11014(compound);
	}

	// ITickable
	@Override
	public void method_16896() {
        if (field_11863.method_8608()){
	        return;
        }
	    if (field_11863.method_8510() % 25 != 0) {
	        return;
        }
		if (field_11863.method_8479(method_11016())) {
			BlockAlarm.setActive(true, field_11863, field_11867);
			switch (selectedSound) {
				case 1:
					field_11863.method_8465(null, field_11867.method_10263(), field_11867.method_10264(), field_11867.method_10260(), ModSounds.ALARM, class_3419.field_15245, 4F, 1F);
					break;
				case 2:
					field_11863.method_8465(null, field_11867.method_10263(), field_11867.method_10264(), field_11867.method_10260(), ModSounds.ALARM_2, class_3419.field_15245, 4F, 1F);
					break;
				case 3:
					field_11863.method_8465(null, field_11867.method_10263(), field_11867.method_10264(), field_11867.method_10260(), ModSounds.ALARM_3, class_3419.field_15245, 4F, 1F);
					break;
			}
		} else  {
			BlockAlarm.setActive(false, field_11863, field_11867);
		}
	}

	// IToolDrop
	@Override
	public class_1799 getToolDrop(final class_1657 entityPlayer) {
		return TRContent.Machine.ALARM.getStack();
	}
}
