/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.blocks.generator;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.fabricmc.fabric.api.block.FabricBlockSettings;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1836;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2498;
import net.minecraft.class_2561;
import net.minecraft.class_2585;
import net.minecraft.class_2680;
import net.minecraft.class_3419;
import net.minecraft.class_3614;
import net.minecraft.class_3965;
import reborncore.api.ToolManager;
import techreborn.init.ModSounds;

import javax.annotation.Nullable;
import java.util.List;

public class BlockFusionCoil extends class_2248 {

	public BlockFusionCoil() {
		super(FabricBlockSettings.of(class_3614.field_15953).strength(2f, 2f).sounds(class_2498.field_11533).build());
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 worldIn, class_2338 pos, class_1657 playerIn,
							  class_1268 hand, class_3965 hitResult) {

		class_1799 tool = playerIn.method_5998(class_1268.field_5808);
		if (!tool.method_7960() && ToolManager.INSTANCE.canHandleTool(tool)) {
			if (ToolManager.INSTANCE.handleTool(tool, pos, worldIn, playerIn, hitResult.method_17780(), false)) {
				if (playerIn.method_5715()) {
					class_1799 drop = new class_1799(this);
					method_9577(worldIn, pos, drop);
					worldIn.method_8465(null, playerIn.method_23317(), playerIn.method_23318(), playerIn.method_23321(), ModSounds.BLOCK_DISMANTLE,
							class_3419.field_15245, 0.6F, 1F);
					if (!worldIn.field_9236) {
						worldIn.method_8652(pos, class_2246.field_10124.method_9564(), 2);
					}
					return class_1269.field_5812;
				}
			}
		}
		return class_1269.field_5811;
	}

	@Environment(EnvType.CLIENT)
	@Override
	public void method_9568(class_1799 stack, @Nullable class_1922 worldIn, List<class_2561> tooltip,
			class_1836 flagIn) {
		super.method_9568(stack, worldIn, tooltip, flagIn);
		// TODO: Translate
		tooltip.add(new class_2585("Right click Fusion Control computer to auto place"));
	}
}