/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.entities;

import net.minecraft.class_1299;
import net.minecraft.class_1309;
import net.minecraft.class_1313;
import net.minecraft.class_1541;
import net.minecraft.class_1937;
import net.minecraft.class_2398;
import net.minecraft.class_243;
import reborncore.common.explosion.RebornExplosion;
import techreborn.config.TechRebornConfig;

/**
 * Created by Mark on 13/03/2016.
 */
public class EntityNukePrimed extends class_1541 {

	public EntityNukePrimed(class_1299<EntityNukePrimed> entityType,  class_1937 world) {
		super(entityType, world);
		method_6967(TechRebornConfig.nukeFuseTime);
	}

	public EntityNukePrimed(class_1937 world, double x, double y, double z, class_1309 tntPlacedBy) {
		super(world, x, y, z, tntPlacedBy);
		method_6967(TechRebornConfig.nukeFuseTime);
	}

	@Override
	public void method_5773() {
		this.field_6014 = this.method_23317();
		this.field_6036 = this.method_23318();
		this.field_5969 = this.method_23321();

		class_243 velocity = method_18798();
		double motionX = velocity.field_1352;
		double motionY = velocity.field_1351;
		double motionZ = velocity.field_1350;

		if (!this.method_5740()) {
			this.method_18799(this.method_18798().method_1031(0.0D, -0.04D, 0.0D));
		}

		this.method_5784(class_1313.field_6308, this.method_18798());
		this.method_18799(this.method_18798().method_1021(0.98D));
		if (this.field_5952) {
			this.method_18799(this.method_18798().method_18805(0.7D, -0.5D, 0.7D));
		}

		method_18799(new class_243(motionX, motionZ, motionY));

		method_6967(method_6968() - 1);

		if (method_6968() <= 0) {
			this.method_5650();
			if (!this.field_6002.field_9236) {
				explodeNuke();
			}
		} else {
			this.method_5713();
			this.field_6002.method_8406(class_2398.field_11251, this.method_23317(), this.method_23318() + 0.5D, this.method_23321(), 0.0D, 0.0D, 0.0D);
		}
	}

	public void explodeNuke() {
		if (!TechRebornConfig.nukeEnabled) {
			return;
		}
		RebornExplosion nukeExplosion = new RebornExplosion(method_5704(), field_6002, TechRebornConfig.nukeRadius);
		nukeExplosion.setLivingBase(method_6970());
		nukeExplosion.explode();
	}
}
